#!/usr/bin/perl -w

# Author   : Benoit PAPILLAULT <benoit.papillault@free.fr>
# Creation : 17/03/2001

# Dump all buffer contents from a first to a last URB.

$offset = 0;

while (<>) {
    if (/[0-9]+[ \t]+[0-9]+:[0-9]+:[0-9]+[ \t]+[0-9a-f]+: ([0-9a-f ]+)/) {
	@list = split / /, $1;
	$idx = 0;

	# printf("/* 0x%x */ ", $offset);

	foreach $byte (@list) {
	    if ($idx == 0) {
		print "  ";
	    }

	    print "0x$byte, ";

	    $offset ++;
	    $idx ++;

	    if ($idx == 16) {
		print "\n";
		$idx = 0;
	    }
	}

	print "  ";
	foreach $byte (@list) {
	    $dec = hex ($byte);
	    $ascii = '.';
	    if ($dec >= 32 && $dec < 128) {
		$ascii = chr($dec);
	    }

	    print "$ascii";
	}
	print "\n";
    }
    else {
	print $_;
    }
}
